<?

/* functions.php - beinhaltet ntzliche Funktionen (c) 2001 The X-Crew */

// \r\n eines Strings lschen
function killnl ($String) {
	$String = str_replace("\r\n", "", $String);
	return $String;
}

// Datumstring lesbar machen
function makedatum($text,$timecolor) {
	$jahr = substr($text,0,4);
	$monat = substr($text,4,2);
	switch ($monat) {
		case "01":
			$monat = "Januar";
			break;
		case "02":
			$monat = "Februar";
			break;
		case "03":
			$monat = "Mrz";
			break;
		case "04":
			$monat = "Februar";
			break;
		case "05":
			$monat = "Mai";
			break;
		case "06":
			$monat = "Juni";
			break;
		case "07":
			$monat = "Juli";
			break;
		case "08":
			$monat = "August";
			break;
		case "09":
			$monat = "September";
			break;
		case "10":
			$monat = "Oktober";
			break;
		case "11":
			$monat = "November";
			break;
		case "12":
			$monat = "Dezember";
			break;
	}
	$tag = substr($text,6,2);
	$stunde = substr($text,8,2);
	$minute = substr($text,10,2);
	$text = "$tag. $monat $jahr <font color=$timecolor>$stunde:$minute</font>";
	return $text;
}

// Registrierungsdatum lesbar machen
function makeregdatum($String) {
	$jahr = substr($String,0,4);
	$monat = substr($String,4,2);
	switch ($monat) {
		case "01":
			$monat = "Januar";
			break;
		case "02":
			$monat = "Februar";
			break;
		case "03":
			$monat = "Mrz";
			break;
		case "04":
			$monat = "Februar";
			break;
		case "05":
			$monat = "Mai";
			break;
		case "06":
			$monat = "Juni";
			break;
		case "07":
			$monat = "Juli";
			break;
		case "08":
			$monat = "August";
			break;
		case "09":
			$monat = "September";
			break;
		case "10":
			$monat = "Oktober";
			break;
		case "11":
			$monat = "November";
			break;
		case "12":
			$monat = "Dezember";
			break;
	}
	$reg_datum = "$monat $jahr";
	return $reg_datum;
}

// Benutzernamen aus Benutzerdatei extrahieren
function get_user_name ($String) {
	$user_daten = file("members/$String.xbb");
	if (killnl($user_daten[4]) == "killed" || killnl($userdatei_daten[4]) == "5") $user_name = "Gelschter User"; else $user_name = killnl($user_daten[0]);
	return $user_name;
}

// Benutzerpw aus Benutzerdatei extrahieren
function get_user_pw ($String) {
	$userdatei_daten = file("members/$String.xbb");
	$user_pw = killnl($userdatei_daten[2]);
	return $user_pw;
}

// Echter Benutzerstatus aus Benutzerdatei extrahieren
function get_real_user_status ($user_id) {
	$userdatei_daten = file("members/$user_id.xbb");
	$user_status = killnl($userdatei_daten[4]);
	return $user_status;
}

// Benutzerstatus aus Benutzerdatei extrahieren
function get_user_status ($user_id,$var_admin,$var_mod,$var_banned,$var_killed) {
	$userdatei_daten = file("members/$user_id.xbb");
	$user_prestatus = killnl($userdatei_daten[4]);
	switch($user_prestatus) {
		case "1":
			$user_status = $var_admin;
		break;

		case "2":
			$user_status = $var_mod;
		break;

		case "3":
			$up = get_user_posts($user_id);
			$ranks = file("foren/rank.xbb"); $ranks_anzahl = sizeof($ranks);
			for ($i = 0; $i < $ranks_anzahl; $i++) {
				$aktueller_rank = explode("",$ranks[$i]);
				if ($up >= $aktueller_rank[2] && $up <= $aktueller_rank[3]) { $user_status = $aktueller_rank[1]; break; }
			}
		break;

		case "4":
			$user_status = $var_banned;
		break;

		case "5":
			$user_status = $var_killed;
		break;
	}
	return $user_status;
}

// BenutzerEmail aus Benutzerdatei extrahieren
function get_user_email ($String) {
	$userdatei_daten = file("members/$String.xbb");
	$user_email = killnl($userdatei_daten[3]);
	return $user_email;
}

// Benutzer Posts aus Benutzerdatei extrahieren
function get_user_posts ($String) {
	$userdatei_daten = file("members/$String.xbb");
	if (killnl($userdatei_daten[4]) == "killed" || killnl($userdatei_daten[4]) == "5") $user_posts = 0; else $user_posts = killnl($userdatei_daten[5]);
	return $user_posts;
}

// Benutzer Registrierungsdatum aus Benutzerdatei extrahieren
function get_user_regdatum ($String) {
	$userdatei_daten = file("members/$String.xbb");
	$user_regdatum = makeregdatum(killnl($userdatei_daten[6]));
	return $user_regdatum;
}

// Benutzer Signatur aus Benutzerdatei extrahieren
function get_user_signatur ($user_id) {
	$userdatei_daten = file("members/$user_id.xbb");
	if (killnl($userdatei_daten[4]) == "killed" || killnl($userdatei_daten[4]) == "5") $user_signatur = "";
	else {
		$user_signatur = killnl($userdatei_daten[7]);
		if(substr_count($user_signatur,"[") > 0 && substr_count($user_signatur,"]") > 0) {
			$user_signatur = preg_replace("#\[color=(.*?)\](.*?)\[/color\]#si",'<font color="\1">\2</font>',$user_signatur);
			$user_signatur = preg_replace("#\[u\](.*?)\[/u\]#si",'<u>\1</u>',$user_signatur);
			$user_signatur = preg_replace("#\[code\](.*?)\[/code\]#si",'<code><big>\1</big></code></tt>',$user_signatur);
			$user_signatur = preg_replace("#\[s\](.*?)\[/s\]#si",'<s>\1</s>',$user_signatur);
			$user_signatur = preg_replace("#\[i\](.*?)\[/i\]#si",'<i>\1</i>',$user_signatur);
			$user_signatur = preg_replace("#\[b\](.*?)\[/b\]#si",'<b>\1</b>',$user_signatur);
			$user_signatur = preg_replace("#\[url\]([a-z]+?://){1}(.*?)\[/url\]#si",'<A HREF="\1\2" TARGET="_blank">\1\2</A>',$user_signatur);
			$user_signatur = preg_replace("#\[url\](.*?)\[/url\]#si",'<A HREF="http://\1" TARGET="_blank">\1</A>',$user_signatur);
			$user_signatur = preg_replace("#\[url=([a-z]+?://){1}(.*?)\](.*?)\[/url\]#si",'<A HREF="\1\2" TARGET="_blank">\3</A>',$user_signatur);
			$user_signatur = preg_replace("#\[url=(.*?)\](.*?)\[/url\]#si",'<A HREF="http://\1" TARGET="_blank">\2</A>',$user_signatur);
			$user_signatur = preg_replace("#\[email\](.*?)\[/email\]#si",'<A HREF="mailto:\1">\1</A>',$user_signatur);
			$user_signatur = preg_replace("/\[img\](.*?)\[\/img\]/si", "<IMG SRC=\"\\1\" BORDER=\"0\">", $user_signatur);
		}
	}
	return $user_signatur;
}

// Benutzer Homepage aus Benutzerdatei extrahieren
function get_user_hp($user_id) {
	$userdatei_daten = file("members/$user_id.xbb");
	if (killnl($user_daten[4]) == "killed" || killnl($userdatei_daten[4]) == "5") $user_hp = "";
	else {
		if(substr(killnl($userdatei_daten[9]),0,7) == "http://" || killnl($userdatei_daten[9]) == "") $user_hp = killnl($userdatei_daten[9]);
		else $user_hp = "http://" . killnl($userdatei_daten[9]);
	}
	return $user_hp;
}

// Benutzer Bild aus Benutzerdatei extrahieren
function get_user_pic($user_id) {
	$userdatei_daten = file("members/$user_id.xbb");
	if (killnl($userdatei_daten[10]) == "" || killnl($userdatei_daten[4]) == "5") $user_pic = "";
	else {
		if(substr(killnl($userdatei_daten[10]),0,7) == "http://") $user_pic = killnl($userdatei_daten[10]);
		else $user_pic = "http://" . killnl($userdatei_daten[10]);

		//$user_pic = "<img width=90 height=120 src=" . $user_pic . ">";
		//error_reporting(32); // Stellt sicher, dass nicht angezeigt wird, wenn das Bild nicht existiert
		$user_pic_size = getimagesize($user_pic) or $test = 1;
		if($test != 1) {
			if($user_pic_size[0] > 90 && $user_pic_size[1] > 120) $user_pic = "<img width=90 height=120 src=$user_pic>";
			elseif($user_pic_size[0] > 90 && $user_pic_size[1] <= 120) $user_pic = "<img width=90 src=$user_pic>";
			elseif($user_pic_size[0] <= 90 && $user_pic_size[1] > 120) $user_pic = "<img height=120 src=$user_pic>";
			else $user_pic = "<img src=$user_pic>";
		}
		else $user_pic = "<img width=90 height=120 src=" . $user_pic . ">";

	}
	return $user_pic;
}

// Letzten Topic eines Forums herausfinden
function get_last_post ($forum_id,$timecolor) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($forum_id == $aktuelles_forum[0]) {
			$last_post_daten = explode(",",$aktuelles_forum[9]);
			if ($last_post_daten[2] != "") {
				if($last_post_daten[0] == "") { // Alte Version
					$last_post = makedatum($last_post_daten[2],$timecolor) . " von " . get_user_name($last_post_daten[1]);
				}
				else { // Neue Version
					$last_post = "<a href=index.php?mode=viewthread&forum_id=$aktuelles_forum[0]&thread=$last_post_daten[0]>" . get_thread_name($aktuelles_forum[0],$last_post_daten[0]) . "</a> (von <a href=index.php?upb=profile&profile_id=$last_post_daten[1]>" . get_user_name($last_post_daten[1]) . "</a>)<br>am " . makedatum($last_post_daten[2],$timecolor);
				}
			}
			else $last_post = "Kein Beitrag vorhanden";
			break;
		}
	}
	if (!$last_post) echo "Forum nicht vorhanden!";
	return $last_post;
}

// Moderatoren eines Forums herausfinden
function get_forum_mods ($forum_id) {
	$foren_file = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_file);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_file[$i]);
		if ($aktuelles_forum[0] == $forum_id) {
			if ($aktuelles_forum[11] != "") {
				$forum_mods = explode(",", $aktuelles_forum[11]); $mods_anzahl = sizeof($forum_mods);
				for ($y = 0; $y < $mods_anzahl; $y++) $mods[$y] = "<a href=index.php?upb=profile&profile_id=$forum_mods[$y] onfocus=this.blur()>" . get_user_name($forum_mods[$y]) . "</a>";
				$mods = implode(", ",$mods);
			}
			else $mods = "";
			break;
		}
	}
	if (!$mods) $mods = "";
	return $mods;
}

// Herausfinden, ob ein User Moderator eines bestimmten Forums ist
function test_mod ($forum_id, $user_id) {
	$is_mod = 0;
	if($user_id != 0) {
		$foren_file = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_file);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			$aktuelles_forum = explode("", $foren_file[$i]);
			if ($aktuelles_forum[0] == $forum_id) {
				$forum_mods = explode(",", $aktuelles_forum[11]); $mods_anzahl = sizeof($forum_mods);
				for ($y = 0; $y < $mods_anzahl; $y++) {
					if ($forum_mods[$y] == $user_id) {
						$is_mod = 1;
						break;
					}

				}
				break;
			}
		}
	}
	return $is_mod;
}


// Neue Linien in <br>s umwandeln
function nlbr ($text) {
	$text = str_replace("\r\n", "<br>", $text);
	return $text;
}

// <br>s in neue Linien umwandeln
function brnl ($text) {
	$text = str_replace("<br>", "\r\n", $text);
	return $text;
}

// Forumname herausfinden
function get_forum_name ($text) {
	$forendaten = file("foren/foren.xbb"); $forenanzahl = sizeof($forendaten);
	for ($i = 0; $i < $forenanzahl; $i++) {
		$aktuelles_forum = explode("", $forendaten[$i]);
		if ($aktuelles_forum[0] == $text) {
			$forumname = $aktuelles_forum[1];
			break;
		}
	}
	return $forumname;
}

// Forumstatus herausfinden
function get_forum_status ($forum_id) {
	$forendaten = file("foren/foren.xbb"); $forenanzahl = sizeof($forendaten);
	for ($i = 0; $i < $forenanzahl; $i++) {
		$aktuelles_forum = explode("", $forendaten[$i]);
		if ($aktuelles_forum[0] == $forum_id) {
			$forumstatus = $aktuelles_forum[8];
			break;
		}
	}
	return $forumstatus;
}

// Topicname herausfinden
function get_thread_name ($forum_id, $thread_id) {
	$thread_datei = @file("foren/$forum_id-$thread_id.xbb");
	$thread_info = explode("", $thread_datei[0]);
	return $thread_info[1];
}

// Themenanzahl eines Forums um 1 erhhen
function increase_topic_number($text) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($text == $aktuelles_forum[0]) {
			$aktuelles_forum[3]++;
			$foren_datei[$i] = implode("", $aktuelles_forum);
			$save = 1;
			break;
		}
		$foren_datei[$i] = implode("", $aktuelles_forum);
	}
	if ($save == 1) {
		$fp = fopen("foren/foren.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			fwrite($fp, $foren_datei[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
	else echo "Forum existiert nicht!";
}

// Themenanzahl eines Forums um 1 verringern
function decrease_topic_number ($text) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($text == $aktuelles_forum[0]) {
			$aktuelles_forum[3] = $aktuelles_forum[3] - 1;
			$foren_datei[$i] = implode("", $aktuelles_forum);
			$save = 1; break;
		}
		$foren_datei[$i] = implode("", $aktuelles_forum);
	}
	if ($save == 1) {
		$fp = fopen("foren/foren.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			fwrite($fp, $foren_datei[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
	else echo "Forum existiert nicht!";
}

// Beitragsanzahl eines Forums um 1 erhhen
function increase_posts_number ($String) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($String == $aktuelles_forum[0]) {
			$aktuelles_forum[4] = $aktuelles_forum[4] + 1;
			$foren_datei[$i] = implode("", $aktuelles_forum);
			$save = 1; break;
		}
		$foren_datei[$i] = implode("", $aktuelles_forum);
	}
	if ($save == 1) {
		$fp = fopen("foren/foren.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			fwrite($fp, $foren_datei[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
	else echo "Forum existiert nicht!";
}

// Beitragsanzahl eines Forums um x erhhen
function increase_posts_numberx($forum_id,$posts) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($forum_id == $aktuelles_forum[0]) {
			$aktuelles_forum[4] = $aktuelles_forum[4] + $posts;
			$foren_datei[$i] = implode("", $aktuelles_forum);
			$save = 1; break;
		}
		$foren_datei[$i] = implode("", $aktuelles_forum);
	}
	if ($save == 1) {
		$fp = fopen("foren/foren.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			fwrite($fp, $foren_datei[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
	else echo "Forum existiert nicht!";
}

// Beitragsanzahl eines Forums um x veringern
function decrease_posts_number ($String, $post_anzahl) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($String == $aktuelles_forum[0]) {
			$aktuelles_forum[4] = $aktuelles_forum[4] - $post_anzahl;
			$foren_datei[$i] = implode("", $aktuelles_forum);
			$save = 1; break;
		}
		$foren_datei[$i] = implode("", $aktuelles_forum);
	}
	if ($save == 1) {
		$fp = fopen("foren/foren.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			fwrite($fp, $foren_datei[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
	else echo "Forum existiert nicht!";
}

// Neusten Beitrag eines Forums updaten
function update_last_post ($forum_id,$datum,$creator_id,$topic_id) {
	$foren_datei = file("foren/foren.xbb"); $foren_anzahl = sizeof($foren_datei);
	for ($i = 0; $i < $foren_anzahl; $i++) {
		$aktuelles_forum = explode("", $foren_datei[$i]);
		if ($forum_id == $aktuelles_forum[0]) {
			$aktuelles_forum[9] = $topic_id . "," . $creator_id . "," . $datum;
			$aktuelles_forum[6] = time();
			$foren_datei[$i] = implode("", $aktuelles_forum);
			$save = 1; break;
		}
		$foren_datei[$i] = implode("", $aktuelles_forum);
	}
	if ($save == 1) {
		$fp = fopen("foren/foren.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $foren_anzahl; $i++) {
			fwrite($fp, $foren_datei[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
	else echo "Forum existiert nicht!";
}

// Open/Closed Status eines Topics herausfinden
function get_topic_status ($forum_id, $topic_id) {
	$topic_datei = file("foren/$forum_id-$topic_id.xbb");
	$topic_info = explode("", $topic_datei[0]);
	return $topic_info[0];
}

// Sendmail Status eines Topics herausfinden
function get_sendmail_status($forum_id,$topic_id) {
	$topic_datei = file("foren/$forum_id-$topic_id.xbb");
	$topic_info = explode("", $topic_datei[0]);
	return $topic_info[4];
}

// Ersteller eines Topics herausfinden
function get_topic_creator($forum_id,$topic_id) {
	$topic_datei = file("foren/$forum_id-$topic_id.xbb");
	$topic_info = explode("", $topic_datei[0]);
	return $topic_info[2];
}

// Bild eines Topics herausfinden
function get_topic_smilie ($forum_id, $topic_id) {
	$topic_datei = file("foren/$forum_id-$topic_id.xbb");
	$topic_info = explode("", $topic_datei[0]);
	$topic_bild = $topic_info[3];
	if ($topic_bild == "") $topic_bild = 1;
	return $topic_bild;
}

// Ersteller ID eines bestimmten Posts herausfinden
function get_post_creator_id ($forum_id, $topic_id, $post_id) {
	$post_file = file("foren/$forum_id-$topic_id.xbb"); $post_file_anzahl = sizeof($post_file);
	for ($i = 1; $i < $post_file_anzahl; $i++) {
		$aktuellerpost_daten = explode("", $post_file[$i]);
		if ($aktuellerpost_daten[0] == $post_id) {
			$post_creator_id = $aktuellerpost_daten[1];
			break;
		}
	}
	return $post_creator_id;
}

// Ein beliebiges Post herausfinden
function get_post ($forum_id,$topic_id,$post_id,$user_id) {
	if(check_user_access($user_id,$forum_id) == 1 || get_forum_status($forum_id) == 2) {
		$post_file = file("foren/$forum_id-$topic_id.xbb"); $post_file_anzahl = sizeof($post_file);
		for ($i = 1; $i < $post_file_anzahl; $i++) {
			$aktuellerpost_daten = explode("", $post_file[$i]);
			if ($aktuellerpost_daten[0] == $post_id) {
				$post = brnl($aktuellerpost_daten[3]);
				break;
			}
		}
		return $post;
	}
	else echo "Kein Zugriff auf dieses Post!";
}

// IP des Erstellers eines beliebigen Posts herausfinden
function get_post_ip ($forum_id, $topic_id, $post_id) {
	$post_file = file("foren/$forum_id-$topic_id.xbb"); $post_file_anzahl = sizeof($post_file);
	for ($i = 1; $i < $post_file_anzahl; $i++) {
		$aktuellerpost_daten = explode("", $post_file[$i]);
		if ($aktuellerpost_daten[0] == $post_id) {
			$post_ip = $aktuellerpost_daten[4];
			break;
		}
	}
	return $post_ip;
}

// Signatur Status eines Posts anzeigen
function get_post_sigstatus ($forum_id, $topic_id, $post_id) {
	$post_file = file("foren/$forum_id-$topic_id.xbb"); $post_file_anzahl = sizeof($post_file);
	for ($i = 1; $i < $post_file_anzahl; $i++) {
		$aktuellerpost_daten = explode("", $post_file[$i]);
		if ($aktuellerpost_daten[0] == $post_id) {
			$sigstatus = $aktuellerpost_daten[5];
			break;
		}
	}
	return $sigstatus;
}

// Smilie Status eines Posts anzeigen
function get_post_smistatus ($forum_id, $topic_id, $post_id) {
	$post_file = file("foren/$forum_id-$topic_id.xbb"); $post_file_anzahl = sizeof($post_file);
	for ($i = 1; $i < $post_file_anzahl; $i++) {
		$aktuellerpost_daten = explode("", $post_file[$i]);
		if ($aktuellerpost_daten[0] == $post_id) {
			$smistatus = $aktuellerpost_daten[7];
			break;
		}
	}
	return $smistatus;
}

// UPB-Code Status eines Posts anzeigen
function get_post_upbcodestatus ($forum_id, $topic_id, $post_id) {
	$post_file = file("foren/$forum_id-$topic_id.xbb"); $post_file_anzahl = sizeof($post_file);
	for ($i = 1; $i < $post_file_anzahl; $i++) {
		$aktuellerpost_daten = explode("", $post_file[$i]);
		if ($aktuellerpost_daten[0] == $post_id) {
			$upbcodestatus = $aktuellerpost_daten[8];
			break;
		}
	}
	return $upbcodestatus;
}

// Ein Topic zum aktuellsten machen
function rank_topic ($forum_id, $topic_id) {
	$topic_file = file("foren/$forum_id-threads.xbb"); $topic_anzahl = sizeof($topic_file);
	for ($i = 0; $i < $topic_anzahl; $i++) {
		if ($topic_id == killnl($topic_file[$i])) {
			$topic_file[$i] = "";
			$topic_file[$topic_anzahl] = $topic_id . "\r\n";
			$save = 1; break;
		}
	}
	if ($save == 1) {
		$topic_anzahl_neu = $topic_anzahl + 1;
		$fp = fopen("foren/$forum_id-threads.xbb", "w"); flock($fp, LOCK_EX);
		for ($i = 0; $i < $topic_anzahl_neu; $i++) {
			fwrite($fp, $topic_file[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
}

// Herausfinden, ob ein Username schon existiert
function check_name ($user_name) {
	$user_exist = 0; $user_name = strtolower($user_name);
	$members = file("members/members.xbb"); $members = $members[0];
	for ($i = 1; $i <= $members; $i++) {
		$aktueller_member = file("members/$i.xbb");
		$aktueller_member_name = killnl($aktueller_member[0]);
		if (strtolower($aktueller_member_name) == $user_name) {
			$user_exist = 1;
			break;
		}
	}
	return $user_exist;
}

// Die Postanzahl eines Users um 1 erhhen
function increase_user_posts ($user_id) {
	$user_daten = file("members/$user_id.xbb"); $user_daten_size = sizeof($user_daten);
	$user_daten[5] = killnl($user_daten[5]) + 1; $user_daten[5] = "$user_daten[5]\r\n";
	$fp = fopen("members/$user_id.xbb", "w"); flock($fp, LOCK_EX);
	for ($i = 0; $i < $user_daten_size; $i++) {
		fwrite($fp, $user_daten[$i]);
	}
	flock($fp, LOCK_UN); fclose($fp);
}

// berprfen, ob ein User ein Forum betreten darf
function check_user_access ($user_id, $forum_id) {
	$access = 0; $user_daten = file("members/$user_id.xbb");
	if(test_mod($forum_id,$user_id) == 1 || get_real_user_status($user_id) == 1) $access = 1;
	else {
		$user_daten_access = explode(",", killnl($user_daten[8])); $user_daten_access_size = sizeof($user_daten_access);
		for ($i = 0; $i < $user_daten_access_size; $i++) {
			if ($user_daten_access[$i] == $forum_id) $access = 1;
			break;
		}
	}
	return $access;
}

// Einen String HTML-kompatibel machen
function mutate ($text) {
	$text = htmlspecialchars(stripslashes($text));
	return $text;
}

// mutate() wieder teilweise rckgngig machen
function demutate($text) {
	$text = str_replace("&amp;","&",$text);
	$text = str_replace("&quot;","\"",$text);
	$text = str_replace("&lt;","<",$text);
	$text = str_replace("&gt;",">",$text);
	return $text;
}

// Text-Smilies in Grafiken umwandeln
function make_smilies($text) {
	$sm_file = file("foren/smilies.xbb"); $sm_file_size = sizeof($sm_file);
	for ($i = 0; $i < $sm_file_size; $i++) {
		$akt_sm = explode("",$sm_file[$i]);
		$text = str_replace($akt_sm[1], "<img border=0 src=\"" . $akt_sm[2] . "\">", $text);
	}
	return $text;
}


// Ranking Bild bestimmen
function get_rank_pic($user_id,$var_admin,$var_mod,$var_banned,$var_killed) {
	$rank_pic = "";
	$user_status = get_user_status($user_id,$var_admin,$var_mod,$var_banned,$var_killed);
	switch($user_status) {
		case $var_admin:
			$rank_pic = "<img src=images/rank/star3.gif><img src=images/rank/star3.gif><img src=images/rank/star3.gif><img src=images/rank/star3.gif><img src=images/rank/star3.gif><img src=images/rank/star3.gif>";
			break;
		case $var_mod:
			$rank_pic = "<img src=images/rank/star3.gif><img src=images/rank/star3.gif><img src=images/rank/star3.gif><img src=images/rank/star3.gif>";
			break;
		default:
			$up = get_user_posts($user_id);
			if($up < 0) $rank_pic = "";
			else {
				$ranks = file("foren/rank.xbb"); $ranks_anzahl = sizeof($ranks);
				for ($i = 0; $i < $ranks_anzahl; $i++) {
					$aktueller_rank = explode("",$ranks[$i]);
					if ($up >= $aktueller_rank[2] && $up <= $aktueller_rank[3]) {
						for($j = 0; $j < $aktueller_rank[4]; $j++) {
							$rank_pic = $rank_pic . "<img src=images/rank/star3.gif>";
						}
					}
				}
			}
			break;
	}
	return $rank_pic;
}

// Kategorie Name herausfinden
function get_kg_name($kg_id) {
	$kg = file("foren/kg.xbb"); $kg_anzahl = sizeof($kg);
	for ($i = 0; $i < $kg_anzahl; $i++) {
		$aktuelle_kg = explode("", $kg[$i]);
		if ($aktuelle_kg[0] == $kg_id) {
			$kg_name = $aktuelle_kg[1];
			break;
		}
	}
	if (!$kg_name) $kg_name = "Kategorie existiert nicht!";
	return $kg_name;
}

// PM (un)gelesen Status herausfinden
function get_pm_status($user_id, $pm_id) {
	$pm = file("members/$user_id.pm"); $pm_anzahl = sizeof($pm);
	for ($i = 0; $i < $pm_anzahl; $i++) {
		$aktuelle_pm = explode("", $pm[$i]);
		if ($aktuelle_pm[0] == $pm_id) {
			$pm_status = $aktuelle_pm[7];
			break;
		}
	}
	return $pm_status;
}

// PM Titel herausfinden
function get_pm_name($user_id, $pm_id) {
	$pm = file("members/$user_id.pm"); $pm_anzahl = sizeof($pm);
	for ($i = 0; $i < $pm_anzahl; $i++) {
		$aktuelle_pm = explode("", $pm[$i]);
		if ($aktuelle_pm[0] == $pm_id) {
			$pm_name = $aktuelle_pm[1];
			break;
		}
	}
	return $pm_name;
}

// PM Ersteller herausfinden
function get_pm_creator($user_id, $pm_id) {
	$pm = file("members/$user_id.pm"); $pm_anzahl = sizeof($pm);
	for ($i = 0; $i < $pm_anzahl; $i++) {
		$aktuelle_pm = explode("", $pm[$i]);
		if ($aktuelle_pm[0] == $pm_id) {
			$creator = $aktuelle_pm[3];
			break;
		}
	}
	return $creator;
}

// PM als ungelesen markieren
function make_read($user_id, $pm_id) {
	$pm = file("members/$user_id.pm"); $pm_anzahl = sizeof($pm);
	for($i = 0; $i < $pm_anzahl; $i++) {
		$aktuelle_pm = explode("", $pm[$i]);
		if ($aktuelle_pm[0] == $pm_id) {
			$aktuelle_pm[7] = 0;
			$save = "yes";
			$pm[$i] = implode("", $aktuelle_pm);
			break;
		}
		$pm[$i] = implode("", $aktuelle_pm);
	}
	if ($save == "yes") {
		$fp = fopen("members/$user_id.pm","w"); flock($fp, LOCK_EX);
		for($i = 0; $i < $pm_anzahl; $i++) {
			fwrite($fp, $pm[$i]);
		}
		flock($fp, LOCK_UN); fclose($fp);
	}
}

// UPB-Code
function upbcode($text) {
	if(substr_count($text,"[") > 0 && substr_count($text,"]") > 0) {
		$text = preg_replace("#\[color=(.*?)\](.*?)\[/color\]#si",'<font color="\1">\2</font>',$text);
		$text = preg_replace("#\[u\](.*?)\[/u\]#si",'<u>\1</u>',$text);
		$text = preg_replace("#\[code\](.*?)\[/code\]#si",'<code><big>\1</big></code></tt>',$text);
		$text = preg_replace("#\[s\](.*?)\[/s\]#si",'<s>\1</s>',$text);
		$text = preg_replace("#\[i\](.*?)\[/i\]#si",'<i>\1</i>',$text);
		$text = preg_replace("#\[b\](.*?)\[/b\]#si",'<b>\1</b>',$text);
		$text = preg_replace("#\[url\]([a-z]+?://){1}(.*?)\[/url\]#si",'<A HREF="\1\2" TARGET="_blank">\1\2</A>',$text);
		$text = preg_replace("#\[url\](.*?)\[/url\]#si",'<A HREF="http://\1" TARGET="_blank">\1</A>',$text);
		$text = preg_replace("#\[url=([a-z]+?://){1}(.*?)\](.*?)\[/url\]#si",'<A HREF="\1\2" TARGET="_blank">\3</A>',$text);
		$text = preg_replace("#\[url=(.*?)\](.*?)\[/url\]#si",'<A HREF="http://\1" TARGET="_blank">\2</A>',$text);
		$text = preg_replace("#\[email\](.*?)\[/email\]#si",'<A HREF="mailto:\1">\1</A>',$text);
		$text = preg_replace("/\[img\](.*?)\[\/img\]/si", "<IMG SRC=\"\\1\" BORDER=\"0\">", $text);
		do {
			$text = preg_replace("#\[quote\](.*?)\[/quote\]#si",'<center><table border=0 cellspacing=0 cellpadding=0 width=85%><tr><td><font size=1><b>Zitat:</b></font><hr noshade><center><table border=0 cellspacing=0 cellpadding=0 width=95%><tr><td><font size=1><i>\1</i></font></td></tr></table></center><hr noshade></td></tr></table></center>',$text);
		}
		while(preg_match("#\[quote\](.*?)\[/quote\]#si",$text));
	}
	return $text;
}

// T-Smilie-Adresse herausfinden
function get_tsmadress($tsm_id) {
	$tsm_file = file("foren/tsmilies.xbb"); $tsm_file_size = sizeof($tsm_file);
	for ($i = 0; $i < $tsm_file_size; $i++) {
		$akt_tsm = explode("",$tsm_file[$i]);
		if ($akt_tsm[0] == $tsm_id) {
			$tsm_adress = $akt_tsm[1];
			break;
		}
	}
	if(!$tsm_adress) $tsm_adress = "images/tsmilies/1.gif";
	return $tsm_adress;
}

// PM senden
function sendpm($target_id,$remote_id,$betreff,$pm,$use_upbcode,$user_smilies) {
	$target_file = file("members/$target_id.pm"); $target_file = array_reverse($target_file); $last_pm = explode("",$target_file[0]); $new_pm_id = $last_pm[0] + 1;
	$towrite = "$new_pm_id" . "$betreff" . "$pm" . "$remote_id" . "" . gmdate("YmdHis") . "$use_smilies" . "$use_upbcode" . "1\r\n";
	$fp = fopen("members/$target_id.pm","a"); flock($fp,LOCK_EX); fwrite($fp,$towrite); flock($fp,LOCK_UN); fclose($fp);
}

// Gegebenenfalls http:// zu einem String dazumachen
function addhttp($text) {
	if(substr($text,0,7) != "http://") $text = "http://" . $text;
	return $text;
}

// NIX (Mir ist grade langweilig)
function nix() {
}

// berprfen, ob ein User noch Moderator eines Forums auer dem angegeben ist
function check_if_mod($forum_id,$user_id) {
	$is_mod = 0;
	$foren_file = file("foren/foren.xbb"); $foren_file_size = sizeof($foren_file);
	for($i = 0; $i < $foren_file_size; $i++) {
		$aktuelles_forum = explode("",$foren_file[$i]);
		if($aktuelles_forum[0] != $forum_id || $forum_id == -1) {
			$aktuelles_forum_mods = explode(",",$aktuelles_forum[11]);
			for($j = 0; $j < sizeof($aktuelles_forum[11]); $j++) {
				if($user_id == $aktuelles_forum_mods[$j]) {
					$is_mod = 1;
					break 2;
				}
			}
		}
	}
	return $is_mod;
}

// Userdatei ndern
function change_user_db($user_id,$db_pos,$db_wert) {
	$user_file = file("members/$user_id.xbb"); $user_file_size = sizeof($user_file);
	$user_file[$db_pos] = $db_wert . "\r\n";
	$fp = fopen("members/$user_id.xbb","w"); flock($fp,LOCK_EX);
	for($i = 0; $i < $user_file_size; $i++) {
		fwrite($fp,$user_file[$i]);
	}
	flock($fp,LOCK_UN); fclose($fp);
}

// time() des letzten Beitrags eines Themas aktualisieren
function update_topic_time($forum_id,$topic_id) {
	$topic_file = file("foren/$forum_id-$topic_id.xbb");
	$topic_status = explode("",$topic_file[0]); $topic_status[5] = time(); $topic_file[0] = implode("",$topic_status);
	$fp = fopen("foren/$forum_id-$topic_id.xbb","w"); flock($fp,LOCK_EX);
	for($i = 0; $i < sizeof($topic_file); $i++) {
		fwrite($fp,$topic_file[$i]);
	}
	flock($fp,LOCK_UN); fclose($fp);
}

// Statuszahl in echten Status umwandeln
function morph_status($status,$posts,$var_admin,$var_mod,$var_banned,$var_killed) {
	switch($status) {
		case "1":
			$status = $var_admin;
		break;

		case "2":
			$status = $var_mod;
		break;

		case "3":
			$ranks = file("foren/rank.xbb"); $ranks_anzahl = sizeof($ranks);
			for ($i = 0; $i < $ranks_anzahl; $i++) {
				$aktueller_rank = explode("",$ranks[$i]);
				if ($posts >= $aktueller_rank[2] && $posts <= $aktueller_rank[3]) { $status = $aktueller_rank[1]; break; }
			}
		break;

		case "4":
			$status = $var_banned;
		break;

		case "5":
			$status = $var_killed;
		break;
	}
	return $status;
}

// berprfen, ob IP Zugang zu einem Forum hat hat
function check_ip_access($ip,$forum_id) {
	$ips = file("foren/ip.xbb"); $access = 1;
	for($i = 0; $i < sizeof($ips); $i++) {
		$akt_ip = explode("",$ips[$i]);
		if($akt_ip[0] == $ip && $akt_ip[2] == $forum_id && ($akt_ip[1] > time() || $akt_ip[1] == -1)) {
			$access = 0; break;
		}
	}
	return $access;
}

// Findet das Ende der Sperrzeit einer IP fr das gesamte Forum heraus
function get_ip_sperre_endtime($ip,$forum_id) {
	$endtime = 0;
	$ips = file("foren/ip.xbb"); $access = 1;
	for($i = 0; $i < sizeof($ips); $i++) {
		$akt_ip = explode("",$ips[$i]);
		if($akt_ip[0] == $ip && $akt_ip[2] == $forum_id && ($akt_ip[1] > time() || $akt_ip[1] == -1)) {
			$endtime = $akt_ip[1];
		}
	}
	return $endtime;
}

?>